// ***********************************************************************
// VISUAL MARRIAGE Applet
//
// Visualizes the algorithm for finding a man-optimal stable marriage.
// The simulated algorithm is the one of Gale and Shapley.
//
// by Rolf Bruderer, Oct 2003
// ***********************************************************************

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import java.util.*;

public class PersonSymbolRenderer
	// TableCellRenderer for Persons.
	// Visualize a Person with its symbol.
	
implements TableCellRenderer
{

	DefaultTableCellRenderer default_renderer;
	
	public PersonSymbolRenderer () {
		default_renderer = new DefaultTableCellRenderer();
	}

	public Component getTableCellRendererComponent (JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column)
	// renders a PreferenceList in a Table.
	{	

		// get person to visualize.
		Person person = (Person) value;
		
		// get persons symbol.
		JComponent component = person.getSymbolComponent ();		
		
		// take properties from default renderer.
		JLabel c = (JLabel) default_renderer.getTableCellRendererComponent (table, value, isSelected, hasFocus, row, column);
		component.setBackground (c.getBackground ());		
		component.setBorder (c.getBorder());				
	
		// return the rendered cell.
       	return component;	    
		
	}
		
}
