// ***********************************************************************
// VISUAL MARRIAGE Applet
//
// Visualizes the algorithm for finding a man-optimal stable marriage.
// The simulated algorithm is the one of Gale and Shapley.
//
// by Rolf Bruderer, Oct 2003
// ***********************************************************************

import java.util.Vector;
import java.util.HashMap;
import java.awt.Color;


public class PreferenceList
// A List of Preferences to persons.

extends Vector

{

	private HashMap highlightColors;
	// for each preference, we can memorize a highlight color (used to display the according preference)
	
	private HashMap backgroundColors;
	// for each preference, we can memorize a background color (used to display the according preference)
	
	PreferenceList() 
	// Constructor
	{
		super();
		highlightColors = new HashMap();
		backgroundColors = new HashMap();
	}

	void setHighlightColor(Person p, Color color)
	// Set the highlight color for the preference belonging to the person 'p'.
	{
		highlightColors.put(p, color);
	}
	
	Color getHighlightColor(Person p) 
	// Get the highlight color for the preference belonging to person 'p'.
	// Return NULL if no highlight.
	{	
		return (Color)highlightColors.get(p);
	}
	
	void clearHighlightColors()
	// clear all set background colors.
	{
		highlightColors.clear();		
	}
	
	void setBackgroundColor(Person p, Color color)
	// Set the background color for the preference belonging to the person 'p'.
	{
		backgroundColors.put(p, color);
	}
	
	Color getBackgroundColor(Person p) 
	// Get the background color for the preference belonging to person 'p'.
	// Return NULL if no background.
	{	
		return (Color)backgroundColors.get(p);
	}
	
	void clearBackgroundColors()
	// clear all set background colors.
	{
		backgroundColors.clear();		
	}
	
	void drag(int fromIndex, int toIndex) 
	// Drag the preference from index 'fromIndex' to the index 'toIndex'.
	{
		Object obj = remove(fromIndex);
		insertElementAt(obj, toIndex);	
	}
	
}	
